
package de.ivu.elect.presentation.kandidatur.action;

import javax.inject.Named;

import de.ivu.elect.business.kandidatur.entity.KandidaturStatus;
import de.ivu.elect.business.kandidatur.entity.Listenkandidatur;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.presentation.wahl.CurrentWahlZulassungspruefungExtended;

@Named(ListenkandidaturZulassungBestaetigenNachtraeglichAmtsannahmeVerweigertAction.COMPONENT_NAME)
public class ListenkandidaturZulassungBestaetigenNachtraeglichAmtsannahmeVerweigertAction extends AbstractListenkandidaturZulassungBestaetigenNachtraeglichAmtsannahmeAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "listenkandidaturZulassungBestaetigenNachtraeglichAmtsannahmeVerweigertAction";

  public ListenkandidaturZulassungBestaetigenNachtraeglichAmtsannahmeVerweigertAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLVORSCHLAG_QS_ZULASSUNG_AENDERN_NACHTRAEGLICH_AMTSANNAHME_VERWEIGERT;
  }

  @Override
  public boolean isDisabledInternal(Listenkandidatur listenkandidatur, CurrentWahlZulassungspruefungExtended currentWahlZulassungspruefung) {
    return isDisabledBySitzberechnungsalgorithmus(listenkandidatur.getWahl()) || !currentWahlZulassungspruefung.isZulassungBestaetigenNachtraeglichAmtsannahmeVerweigertZulaessig(listenkandidatur);
  }

  protected boolean isDisabledBySitzberechnungsalgorithmus(Wahl wahl) {
    return true; // ELECTKOM-1063, erstmal nur gezielt freischalten, da der Sitzberechnungsalgorithmus diese Action unterstützen muss...
  }

  @Override
  protected KandidaturStatus getKandidaturStatus() {
    return KandidaturStatus.ZUGELASSEN_NACHTRAEGLICH_AMTSANNAHME_VERWEIGERT;
  }

  @Override
  protected String getConfirmDialogName() {
    return "ListenkandidaturZulassungBestaetigenNachtraeglichAmtsannahmeVerweigertConfirm";
  }
}
